<?php

/******************************************************
 * $File: //depot/povray/tools/wiki-docgen/common.php $
 * $Revision: #1 $
 * $Change: xxxx $
 * $DateTime: 2014/04/27 18:52:00 $
 * $Author: jholsenback $
 *****************************************************/

ini_set("display_errors", "stdout");

class TagMap {
/* --

	This class contains various functions and variables used to help build
	the tagt map.

-- */

// wiki namespace that contains the target section
var $WikiNS;
public function getWikiNS() {
	return $this->WikiNS;
	}

public function setWikiNS ($NamesSpace) {
	$this->WikiNS = $NameSpace;
	}

// wiki filename that contains the target section
var $WikiFN;
public function getWikiFN() {
	return $this->WikiFN;
	}

public function setWikiFN ($WikiPageTitle, $FileBrand) {
if ( $this->Index == "1.0" ) {
 if ( $FileBrand == "win" ) {
		$this->WikiFN = "Windows_Table_of_Contents";
		}
	elseif ( $FileBrand == "mac" ) {
		$this->WikiFN = "Mac_OS_Table_of_Contents";
		}
	elseif ( $FileBrand == "unx" ) {
		$this->WikiFN = "Unix_Table_of_Contents";
		}
	}
elseif ( $this->Index == "2.0" ) {
	$this->WikiFN = "Tutorial_Table_of_Contents";
	}
elseif ( $this->Index == "3.0" ) {
	$this->WikiFN = "Reference_Table_of_Contents";
	}

// ALL the above are in the "Documentation" namespace so it's hard coded for now.
$this->WikiNS = "Documentation";

}

// document title
var $Title;
public function getTitle() {
	return $this->Title;
	}

public function parseTOCLink ($type, $linesworth) {
$Space = " ";
$Unbar = "_";

$SetA = "a-zA-Z";
$SetB = "a-zA-Z0-9 .";
$SetC = "a-zA-Z0-9 \/\'\(\)\".*,:#&?!_-";

switch ($type) {
	case "header":
		$Pattern = "\=([a-zA-Z\ \-]+)\=";
		$Match = preg_match ("/$Pattern/", $linesworth, $Results);
		if ($Match) {
			$this->Title = $Results[1];
			}
		if (!$Results[1]) {
			$this->Title = "ERROR1";
			}
	break;
	case "subheader":
		$Pattern = "\=\=\[\[([".$SetA."]+):([".$SetC."]+)#([".$SetC."]+)\|([".$SetC."]+)\]\]\=\=";
		$Match = preg_match ("/$Pattern/", $linesworth, $Results);
		if ($Match) {
			$this ->WikiNS = $Results[1];
			$this->WikiFN = preg_replace ("/$Space/", $Unbar, $Results[2]);
			$this->Title = $Results[3];
			}
		else {
			$Pattern = "\=\=\[\[([".$SetA."]+):([".$SetC."]+)\|([".$SetC."]+)\]\]\=\=";
			$Match = preg_match ("/$Pattern/", $linesworth, $Results);
			if ($Match) {
				$this->WikiNS = $Results[1];
				$this->WikiFN = preg_replace ("/$Space/", $Unbar, $Results[2]);
				$this->Title = $Results[2];
				}
			}
	break;
	default:
		$Pattern = "\[\[([a-zA-Z]+):([".$SetC."]+)#([".$SetC."]+)\|([".$SetC."]+)\]\]";
		$Match = preg_match ("/$Pattern/", $linesworth, $Results);
		if ($Match) {
			$this ->WikiNS = $Results[1];
			$this->WikiFN = preg_replace ("/$Space/", $Unbar, $Results[2]);
			$this->Title = $Results[3];
			}
		else {
			$Pattern = "\[\[([a-zA-Z]+):([".$SetC."]+)\|([".$SetC."]+)\]\]";
			$Match = preg_match ("/$Pattern/", $linesworth, $Results);
			if ($Match) {
				$this->WikiNS = $Results[1];
				$this->WikiFN = preg_replace ("/$Space/", $Unbar, $Results[2]);
				$this->Title = $Results[3];
				}
			}
	break;
	}
}

var $Format;
public function getFormat() {
	return $this->Format;
	}

public function setFormat ($format) {
	$this->Format = $format;
	}

// local filename
var $LocalFN;
public function getLocalFN() {
	return $this->LocalFN;
	}
public function setLocalFN ($FileBrand) {
	$Prefix = "Not Set";
	$Dot = "\.";
	$Unbar = "_";

	if ( $this->Index[0] == 1 ) {
		if ( $FileBrand == "win" ) {
			$Prefix = "w";
			}
		elseif ( $FileBrand == "mac" ) {
			$Prefix = "m";
			}
		elseif ( $FileBrand == "unx" ) {
			$Prefix = "u";
			}
		}
	elseif ( $this->Index[0] == 2 ) {
		$Prefix = "t";
		}
	elseif ( $this->Index[0] == 3 ) {
		$Prefix = "r";
		}
	$Section = preg_replace ("/$Dot/", $Unbar, $this->Index);
	$FileName = $Section[0].$Section[1].$Section[2];
	$this->LocalFN = $Prefix.$FileName;
	}

// the anchor
var $Anchor;
public function getAnchor() {
	return $this->Anchor;
	}

public function setAnchor ($FileBrand) {
	$Prefix = "r";
	$Dot = "\.";
	$Unbar = "_";
	if ( $this->Index[0] == 1 ) {
		if ( $FileBrand == "win" ) {
			$Prefix = "w";
			}
		elseif ( $FileBrand == "mac" ) {
			$Prefix = "m";
			}
		elseif ( $FileBrand == "unx" ) {
			$Prefix = "u";
			}
		}
	elseif ( $this->Index[0] == 2 ) {
		$Prefix = "t";
		}
	elseif ( $this->Index[0] == 3 ) {
		$Prefix = "r";
		}
	$FileName = preg_replace ("/$Dot/", $Unbar, $this->Index);
	$this->Anchor = $Prefix.$FileName;
	}

// table of contents index
var $Index;
public function getIndex() {
	return $this->Index;
	}
public function setIndex ($SectionEntry) {
	$this->Index = $SectionEntry;
	}

// navigational aid
var $Prev;
public function getPrev() {
	return $this->Prev;
	}
public function setPrev ($Entry) {
	$this->Prev = $Entry;
	}

// navigational aid
var $Next;
public function getNext() {
	return $this->Next;
	}
public function setNext ($Entry) {
	$this->Next = $Entry;
	}
}
// end of class DocumentMap

/* --

	These next two functions setup and close the requested page

-- */

function PageHeader ($DataBase, $DocNameSpace, $WikiTitle, $CurrentPageTitle) {
$Query = 'select old_text from text where old_id=(select rev_text_id ';
$Query = $Query . 'from revision where rev_id=(select page_latest ';
$Query = $Query . 'from page where page_title="' . $WikiTitle . '" AND page_namespace="';
$Query = $Query . $DocNameSpace . '"));';

$Result = mysql_query($Query)
	or exit (2);

while ($Row = mysql_fetch_array($Result, MYSQL_ASSOC)) {

foreach ($Row as $Page) {
	$Page = FixTags ($Page, $CurrentPageTitle, "");
	}
}

mysql_free_result($Result);
mysql_close ($DataBase);}
// end of function PageHeader

/* --

	Used to insert non wrapping space in various places

--*/

function SomeSpaces ($spaces) {
$index = 0;
$Spaces = "";
while ($index++ < $spaces) {
	$Spaces = $Spaces."&nbsp;";
	}
return $Spaces;}
// end of function SomeSpaces

/* --

	Looks up internal link information in the document map. The caller 'FixTags' passes a
	'page' worth of data. A list of the matches found is and put into an array, then individually
	translated from wiki notation to html:

	[[Documentation:Reference Section 4.1#Sphere|spheres]]

	becomes:

	<a href="r3_4.html#r3_4_1_9">spheres</a>

	$Pattern_Array 'key' for $Pattern:

	$Pattern_Array[0]: each individual match
	$Pattern_Array[1]: wiki filename
	$Pattern_Array[2]: heading title (anchor)
	$Pattern_Array[3]: the URI

-- */

function GetLinkInfo ($Page, $DocMap) {
$Space = " ";
$Unbar = "_";
$ndx = 0;
$Exception = "";
$SetA = "a-zA-Z";
$SetB = "a-zA-Z0-9 .";
$SetC = "a-zA-Z0-9 \/\'\(\)\"\*\&.,?!_-";
$SetD = "a-zA-Z0-9 \/\'\(\)\"\*\&\#.,?!_-";

// multi-link WITH sub-section syntax
$Pattern = "\[{2}([".$SetA."]+):([".$SetC."]+)#([".$SetD."]+)\|:([".$SetD."]+)\|([".$SetD."]+)\]{2}";

if (preg_match_all ("/$Pattern/", $Page, $Pattern_Array)) {
	// everything is an exception until it's found in the docmap
  $Exception = "yes";

	while ( $ndx < count ($Pattern_Array[0])) {
		foreach ($DocMap as $MapEntry) {
			if ($MapEntry->getWikiNS() == $Pattern_Array[1][$ndx] && preg_replace ("/$Unbar/", $Space, $MapEntry->getWikiFN()) == $Pattern_Array[2][$ndx] && $MapEntry->getTitle() == $Pattern_Array[3][$ndx]) {
				$Replacement = "<a href=\"".$MapEntry->getLocalFN().".html#";
				$Replacement = $Replacement.$MapEntry->getAnchor()."\">".$Pattern_Array[5][$ndx]."</a>";
				$Page = str_replace ($Pattern_Array[0][$ndx], $Replacement, $Page);
				$Exception = "no";
				break;
				}
			}
		
		if ($Exception == "yes") {
			echo " Exception(1): ".$Pattern_Array[0][$ndx]."\n";
			}

		$ndx++;
		}
	}

// multi-link WITHOUT sub-section syntax
$Pattern = "\[{2}([".$SetA."]+):([".$SetC."]+)\|:([".$SetD."]+)\|([".$SetD."]+)\]{2}";
$ndx = 0;
$Exception = "yes";

if (preg_match_all ("/$Pattern/", $Page, $Pattern_Array)) {
	// everything is an exception until it's found in the docmap
  $Exception = "yes";

	while ( $ndx < count ($Pattern_Array[0])) {
		foreach ($DocMap as $MapEntry) {
			if ($MapEntry->getWikiNS() == $Pattern_Array[1][$ndx] && preg_replace ("/$Unbar/", $Space, $MapEntry->getWikiFN()) == $Pattern_Array[2][$ndx]) {
				$Replacement = "<a href=\"".$MapEntry->getLocalFN().".html#";
				$Replacement = $Replacement.$MapEntry->getAnchor()."\">".$Pattern_Array[4][$ndx]."</a>";
				$Page = str_replace ($Pattern_Array[0][$ndx], $Replacement, $Page);
				$Exception = "no";
				break;
				}
			}
		
		if ($Exception =="yes") {
			echo " Exception(2): ".$Pattern_Array[0][$ndx]."\n";
			}

		$ndx++;
		}
	}

// wiki-link (WITH sub-section) syntax
$Pattern = "\[{2}([".$SetA."]+):([".$SetC."]+)#([".$SetD."]+)\|([".$SetD."]+)\]{2}";
$ndx = 0;
$Exception = "yes";
	
if (preg_match_all ("/$Pattern/", $Page, $Pattern_Array)) {
	// everything is an exception until it's found in the docmap
  $Exception = "yes";

	while ( $ndx < count ($Pattern_Array[0])) {
		foreach ($DocMap as $MapEntry) {
			if (preg_replace ("/$Unbar/", $Space, $MapEntry->getWikiFN()) == $Pattern_Array[2][$ndx] && $MapEntry->getTitle() == $Pattern_Array[3][$ndx]) {
				$Replacement = "<a href=\"".$MapEntry->getLocalFN().".html#";
				$Replacement = $Replacement.$MapEntry->getAnchor()."\">".$Pattern_Array[4][$ndx]."</a>";
				$Page = str_replace ($Pattern_Array[0][$ndx], $Replacement, $Page);
				$Exception = "no";
				break;
				}
			}

		if ($Exception == "yes") {
			echo " Exception(3): ".$Pattern_Array[0][$ndx]."\n";
			}

		$ndx++;
		}
	}

// wiki-link (WITHOUT sub-section) syntax
$Pattern = "\[{2}([".$SetA."]+):([".$SetD."]+)\|([".$SetD."]+)\]{2}";
$ndx = 0;
$Exception = "yes";
	
if (preg_match_all ("/$Pattern/", $Page, $Pattern_Array)) {
	// everything is an exception until it's found in the docmap
  $Exception = "yes";

	while ( $ndx < count ($Pattern_Array[0])) {
		foreach ($DocMap as $MapEntry) {
			if ($MapEntry->getWikiNS() == $Pattern_Array[1][$ndx] && preg_replace ("/$Unbar/", $Space, $MapEntry->getWikiFN()) == $Pattern_Array[2][$ndx] ) {
				$Replacement = "<a href=\"".$MapEntry->getLocalFN().".html#";
				$Replacement = $Replacement.$MapEntry->getAnchor()."\">".$Pattern_Array[3][$ndx]."</a>";
				$Page = str_replace ($Pattern_Array[0][$ndx], $Replacement, $Page);
				$Exception = "no";
				break;
				}
			}

		if ($Exception =="yes") {
			echo " Exception(4): ".$Pattern_Array[0][$ndx]."\n";
			}

		$ndx++;
		}
	}

return $Page;}
// end of function GetLinkInfo

/* --

	Resolves heading and anchor information using the document map. The caller 'FixTags' passes a
	'page' worth of data. A list of the matches found is and put into an array, then individually
	translated from wiki notation to html:

	===Program Description===

	becomes:

	<h3><a name="t2_1_1"></a>Program Description</h3>

	$Pattern_Array 'key' for $Pattern:

	$Pattern_Array[0]: each individual match
	$Pattern_Array[1]: opening wiki header notation
	$Pattern_Array[2]: heading title
	$Pattern_Array[3]: closing wiki header notation

-- */

function GetAnchorInfo ($Page, $DocMap, $PageTitle) {
	$Space = " ";
	$Unbar = "_";
	$i = 0;
	$Exception = "true";
	$SetA = "a-zA-Z0-9 \/\'\(\)\"\&\.,:?!_-";
	$Pattern = "(\={2,})([".$SetA."]+)(\={2,})";

	preg_match_all ("/$Pattern/", $Page, $Pattern_Array);

	$PrevAnchor = false;
	$OpenDiv = false;
	
	while ($i < count ($Pattern_Array[0])) {
		$MapSize = count($DocMap);
		for ($MapIndex = 0; $MapIndex < $MapSize; $MapIndex++) {
			$MapEntry = $DocMap[$MapIndex];
			$NextAnchor = ($MapIndex < $MapSize - 1 && $i < count ($Pattern_Array[0]) - 1) ? $DocMap[$MapIndex + 1]->getAnchor() : false;
			if (preg_replace ("/$Unbar/", $Space, $MapEntry->getWikiFN()) == $PageTitle && $MapEntry->getTitle() == $Pattern_Array[2][$i]) {
				$Replacement = "";
				if ($OpenDiv)
					$Replacement .= "</div>\n";
				$Replacement .= "<a name=\"".$MapEntry->getAnchor()."\"></a>\n";
        $Replacement .= "<div class=\"content-level-" . strtolower($MapEntry->getFormat()) . "\" contains=\"" . $MapEntry->getTitle() . "\" id=\"" . $MapEntry->getAnchor() . "\">\n";
				$Replacement .= "<".$MapEntry->getFormat().">";
				$Replacement .= $MapEntry->getIndex()." ".$Pattern_Array[2][$i];
				$Replacement .= "</".$MapEntry->getFormat().">";
				$Page = str_replace ($Pattern_Array[0][$i], $Replacement, $Page);
				$Exception = "false";
				$PrevAnchor = $MapEntry->getAnchor();
				$OpenDiv = true;
				break;
			}
		}
		if ( $Exception == "true") {
			echo " Exception(5): ".$Pattern_Array[0][$i]."\n";
		}
		$Exception = "true";
		$i++;
	}

	if ($OpenDiv)
		$Page .= "</div>\n";
	return $Page;
}
// end of function GetAnchorInfo

/* --

	Fixes several tags and links in the header template file.

-- */

function BrandTheHeader ($Page, $PageTitle, $Platform) {
$Pattern = "POV-Ray for PLATFORM";
$Page = str_replace ($Pattern, "POV-Ray for ".$Platform, $Page);

/* Fix up some stuff that the production wiki spam filter wouldn't pass */
$Link = "href=\"index.html\"";
$Page = str_replace ("LINK1", $Link, $Page);

$Link = "href=\"RESOLVE.html\"";
$Page = str_replace ("LINK2", $Link, $Page);

$Link = "href=\"t2_0.html\"";
$Page = str_replace ("LINK3", $Link, $Page);

$Link = "href=\"r3_0.html\"";
$Page = str_replace ("LINK4", $Link, $Page);
/* end spam filter fix up */

if ($Platform == "Windows") {
	$Brand = "Windows";
	$Link = "w1_0";
	}
elseif ($Platform == "Mac OS") {
	$Brand = "Mac OS";
	$Link = "m1_0";
	}
elseif ($Platform == "Unix") {
	$Brand = "Unix";
	$Link = "u1_0";
	}

$Page = str_replace ("RESOLVE", $Link, $Page);
$Page = str_replace ("FIXME", $Brand, $Page);

return $Page;}
// end of function BrandTheHeader

/* --

	This function assembles the fixed panel entries into a string. The <h2> heading
	is the top entry and the <h3> ... <h6> headings make up the list.

-- */

function BuildPageFP ($LocalFilename, $DocMap, $WhichView) {
$FixedPanel = "<!-- NavPanel Begin -->\n<div class=\"NavPanel\">\n<table class=\"NavTable\">\n";

foreach ($DocMap as $MapEntry) {
	if ($MapEntry->getLocalFN() == $LocalFilename && $MapEntry->getFormat() == "h2") {
		$FixedPanel = $FixedPanel."<tr>\n  <td class=\"FixedPanelHeading\">";
		$FixedPanel = $FixedPanel."<a title=\"".$MapEntry->getIndex()."\" href=\"#".$MapEntry->getAnchor()."\">";
		$FixedPanel = $FixedPanel.$MapEntry->getTitle()."</a></td>\n</tr>\n";
		}
	elseif ($MapEntry->getLocalFN() == $LocalFilename && $MapEntry->getFormat() == "h3") {
		$FixedPanel = $FixedPanel."<tr>\n  <td><div class=\"divh2\">";
		$FixedPanel = $FixedPanel."<strong><a title=\"".$MapEntry->getIndex()."\" href=\"#".$MapEntry->getAnchor()."\">";
		$FixedPanel = $FixedPanel.$MapEntry->getTitle()."</a></strong></div></td>\n</tr>\n";
		}
	elseif ($MapEntry->getLocalFN() == $LocalFilename && $MapEntry->getFormat() == "h4") {
		$FixedPanel = $FixedPanel."<tr>\n  <td><div class=\"divh3\">";
		$FixedPanel = $FixedPanel."<a title=\"".$MapEntry->getIndex()."\" href=\"#".$MapEntry->getAnchor()."\">";
		$FixedPanel = $FixedPanel.$MapEntry->getTitle()."</a></div></td>\n</tr>\n";
		}
	if ($WhichView == "LongView") {
		if ($MapEntry->getLocalFN() == $LocalFilename && $MapEntry->getFormat() == "h5") {
			$FixedPanel = $FixedPanel."<tr>\n  <td><div class=\"divh4\">";
			$FixedPanel = $FixedPanel."<a title=\"".$MapEntry->getIndex()."\" href=\"#".$MapEntry->getAnchor()."\">";
			$FixedPanel = $FixedPanel.$MapEntry->getTitle()."</a></div></td>\n</tr>\n";
			}
		elseif ($MapEntry->getLocalFN() == $LocalFilename && $MapEntry->getFormat() == "h6") {
			$FixedPanel = $FixedPanel."<tr>\n  <td><div class=\"divh5\">";
			$FixedPanel = $FixedPanel."<a title=\"".$MapEntry->getIndex()."\" href=\"#".$MapEntry->getAnchor()."\">";
			$FixedPanel = $FixedPanel.$MapEntry->getTitle()."</a></div></td>\n</tr>\n";
			}
		}
	}

// close out the table and div
$Spacer = "<tr>\n  <td><div class=\"divh1\">&nbsp;</div></td>\n</tr>\n";
$FixedPanel = $FixedPanel.$Spacer.$Spacer."</table>\n</div>\n<!-- NavPanel End -->\n\n";
return $FixedPanel;}
// end of function BuildPageFP

/* --

	This function assembles the fixed panel entries into a string. The <h2> heading
	is the top entry and the <h3> ... <h6> headings make up the list.

-- */

function BuildContentsFP ($Flavor, $DocMap, $WhichView) {
$Pattern = "";

if ( preg_match ("/^w/", $Flavor) ) {
	$Pattern = "^w";
	}
elseif ( preg_match ("/^t/", $Flavor) ) {
	$Pattern = "^t";
	}
elseif ( preg_match ("/^r/", $Flavor) ) {
	$Pattern = "^r";
	}
elseif ( preg_match ("/^u/", $Flavor) ) {
	$Pattern = "^u";
	}
elseif ( preg_match ("/^m/", $Flavor) ) {
	$Pattern = "^m";
	}

$FixedPanel = "<!-- NavPanel Begin -->\n<div class=\"NavPanel\">\n<table class=\"NavTable\">\n";

foreach ($DocMap as $MapEntry) {
if ( preg_match ("/$Pattern/", $MapEntry->getLocalFN()) ) {
	if (/*$MapEntry->getLocalFN() == $LocalFilename &&*/ $MapEntry->getFormat() == "h2") {
		$FixedPanel = $FixedPanel."<tr>\n  <td class=\"FixedPanelHeading\">";
		$FixedPanel = $FixedPanel."<a title=\"".$MapEntry->getIndex()."\" href=\"#".$MapEntry->getAnchor()."\">";
		$FixedPanel = $FixedPanel.$MapEntry->getTitle()."</a></td>\n</tr>\n";
		}
	elseif (/*$MapEntry->getLocalFN() == $LocalFilename &&*/ $MapEntry->getFormat() == "h3") {
		$FixedPanel = $FixedPanel."<tr>\n  <td><div class=\"divh2\">";
		$FixedPanel = $FixedPanel."<a title=\"".$MapEntry->getIndex()."\" href=\"#".$MapEntry->getAnchor()."\">";
		$FixedPanel = $FixedPanel.$MapEntry->getTitle()."</a></div></td>\n</tr>\n";
		}
	if ($WhichView == "LongView") {
		if (/*$MapEntry->getLocalFN() == $LocalFilename &&*/ $MapEntry->getFormat() == "h4") {
			$FixedPanel = $FixedPanel."<tr>\n  <td><div class=\"divh3\">";
			$FixedPanel = $FixedPanel."<a title=\"".$MapEntry->getIndex()."\" href=\"#".$MapEntry->getAnchor()."\">";
			$FixedPanel = $FixedPanel.$MapEntry->getTitle()."</a></div></td>\n</tr>\n";
			}
		elseif (/*$MapEntry->getLocalFN() == $LocalFilename &&*/ $MapEntry->getFormat() == "h5") {
			$FixedPanel = $FixedPanel."<tr>\n  <td><div class=\"divh4\">";
			$FixedPanel = $FixedPanel."<a title=\"".$MapEntry->getIndex()."\" href=\"#".$MapEntry->getAnchor()."\">";
			$FixedPanel = $FixedPanel.$MapEntry->getTitle()."</a></div></td>\n</tr>\n";
			}
		elseif (/*$MapEntry->getLocalFN() == $LocalFilename &&*/ $MapEntry->getFormat() == "h6") {
			$FixedPanel = $FixedPanel."<tr>\n  <td><div class=\"divh5\">";
			$FixedPanel = $FixedPanel."<a title=\"".$MapEntry->getIndex()."\" href=\"#".$MapEntry->getAnchor()."\">";
			$FixedPanel = $FixedPanel.$MapEntry->getTitle()."</a></div></td>\n</tr>\n";
			}
		}
	}
}

// close out the table and div
$Spacer = "<tr>\n  <td><div class=\"divh1\">&nbsp;</div></td>\n</tr>\n";
$FixedPanel = $FixedPanel.$Spacer.$Spacer."</table>\n</div>\n<!-- NavPanel End -->\n\n";
return $FixedPanel;}
// end of function BuildContentsFP

/* --

	This function assembles the TOC entries into a string. The <h2> heading
	is the top entry and the <h3> ... <h6> headings make up the list.

-- */

function BuildContentsPage ($Flavor, $DocMap) {
$ContentsPage = "<table>\n";

if ( preg_match ("/^w/", $Flavor) ) {
	$Pattern = "^w";
	}
elseif ( preg_match ("/^m/", $Flavor) ) {
	$Pattern = "^m";
	}
elseif ( preg_match ("/^u/", $Flavor) ) {
	$Pattern = "^u";
	}
elseif ( preg_match ("/^t/", $Flavor) ) {
	$Pattern = "^t";
	}
elseif ( preg_match ("/^r/", $Flavor) ) {
	$Pattern = "^r";
	}
elseif ( preg_match ("/^i/", $Flavor) ) {
	$Pattern = "^i";
	}
else {
	$Pattern = "";
	}

foreach ($DocMap as $MapEntry) {
	if ( preg_match ("/$Pattern/", $MapEntry->getLocalFN()) ) {
		if ($MapEntry->getFormat() == "h2") {
			$ContentsPage = $ContentsPage."<tr>\n  <td class=\"ContentsHeading\"><div class=\"divh1\">"/*.$MapEntry->getIndex()*/;
			//$ContentsPage = $ContentsPage."&nbsp;&nbsp;<a name=\"".$MapEntry->getAnchor()."\"></a>";
			$ContentsPage = $ContentsPage."<a name=\"".$MapEntry->getAnchor()."\"></a>";
			$ContentsPage = $ContentsPage."<a title=\"".$MapEntry->getIndex()."\" href=\"";
			$ContentsPage = $ContentsPage.$MapEntry->getLocalFN().".html#".$MapEntry->getAnchor()."\">";
			$ContentsPage = $ContentsPage.$MapEntry->getTitle()."</a></div></td>\n</tr>\n";
			}
		elseif ($MapEntry->getFormat() == "h3") {
			$ContentsPage = $ContentsPage."<tr>\n  <td><div class=\"divh2\">"/*<strong>".$MapEntry->getIndex()*/;
			//$ContentsPage = $ContentsPage."&nbsp;&nbsp;</strong><a name=\"".$MapEntry->getAnchor()."\"></a>";
			$ContentsPage = $ContentsPage."<a name=\"".$MapEntry->getAnchor()."\"></a>";
			$ContentsPage = $ContentsPage."<a title=\"".$MapEntry->getIndex()."\" href=\"";
			$ContentsPage = $ContentsPage.$MapEntry->getLocalFN().".html#".$MapEntry->getAnchor()."\">";
			$ContentsPage = $ContentsPage.$MapEntry->getTitle()."</a></div></td>\n</tr>\n";
			}
		elseif ($MapEntry->getFormat() == "h4") {
			$ContentsPage = $ContentsPage."<tr>\n  <td><div class=\"divh3\">"/*<strong>".$MapEntry->getIndex()*/;
			//$ContentsPage = $ContentsPage."&nbsp;&nbsp;</strong><a name=\"".$MapEntry->getAnchor()."\"></a>";
			$ContentsPage = $ContentsPage."<a name=\"".$MapEntry->getAnchor()."\"></a>";
			$ContentsPage = $ContentsPage."<a title=\"".$MapEntry->getIndex()."\" href=\"";
			$ContentsPage = $ContentsPage.$MapEntry->getLocalFN().".html#".$MapEntry->getAnchor()."\">";
			$ContentsPage = $ContentsPage.$MapEntry->getTitle()."</a></div></td>\n</tr>\n";
			}
		elseif ($MapEntry->getFormat() == "h5") {
			$ContentsPage = $ContentsPage."<tr>\n  <td><div class=\"divh4\">"/*<strong>".$MapEntry->getIndex()*/;
			//$ContentsPage = $ContentsPage."&nbsp;&nbsp;</strong><a name=\"".$MapEntry->getAnchor()."\"></a>";
			$ContentsPage = $ContentsPage."<a name=\"".$MapEntry->getAnchor()."\"></a>";
			$ContentsPage = $ContentsPage."<a title=\"".$MapEntry->getIndex()."\" href=\"";
			$ContentsPage = $ContentsPage.$MapEntry->getLocalFN().".html#".$MapEntry->getAnchor()."\">";
			$ContentsPage = $ContentsPage.$MapEntry->getTitle()."</a></div></td>\n</tr>\n";
			}
		elseif ($MapEntry->getFormat() == "h6") {
			$ContentsPage = $ContentsPage."<tr>\n  <td><div class=\"divh5\">"/*<strong>".$MapEntry->getIndex()*/;
			//$ContentsPage = $ContentsPage."&nbsp;&nbsp;</strong><a name=\"".$MapEntry->getAnchor()."\"></a>";
			$ContentsPage = $ContentsPage."<a name=\"".$MapEntry->getAnchor()."\"></a>";
			$ContentsPage = $ContentsPage."<a title=\"".$MapEntry->getIndex()."\" href=\"";
			$ContentsPage = $ContentsPage.$MapEntry->getLocalFN().".html#".$MapEntry->getAnchor()."\">";
			$ContentsPage = $ContentsPage.$MapEntry->getTitle()."</a></div></td>\n</tr>\n";
			}
		}
	}


// close out the table and div
//$Spacer = "<tr>\n  <td><div class=\"divh1\">&nbsp;</div></td>\n</tr>\n";

$ContentsPage = $ContentsPage."</table>\n</div>\n\n";
return $ContentsPage;}
// end of function BuildContentsPage

/* --

	Some pattern matching to clean up and translate various "tags"

-- */

function FixTags ($Page, $PageTitle, $DocMap, $Platform, $Images) {
$Space = " ";
$Unbar = "_";
$SetA = "a-zA-Z0-9 .";
$SetB = "a-zA-Z0-9 \/\'\(\)\":?!<>.,*#&_;-";

if ($PageTitle) {
	$PageTitle = preg_replace ("/$Unbar/", $Space, $PageTitle);
	}

// fix the proper page title
$Pattern = '<title>TITLE<\/title>';
$Page = preg_replace ("/$Pattern/", "<title>$PageTitle</title>", $Page);

// fix up the content header
$Pattern = "POV-Ray for PLATFORM";
if (preg_match(("/$Pattern/"), $Page)) {
	$Page = BrandTheHeader ($Page, $PageTitle, $Platform);
	}

// fix up the "platform specific" link on the index page
$Pattern = "A PLATFORM SPECIFIC section";
if (preg_match(("/$Pattern/"), $Page)) {
	$Page = preg_replace ("/$Pattern/", "A [[Documentation:".$Platform." Section 1#Introduction|platform]] specific section", $Page);
	}

// BEGIN these items have "wiki" only meaning so delete them

// the 'wikitalk' bar at the page header
$Pattern = '<!-{2}<wikitalk>-{3}>([[:alnum:][:space:]<>_=|,.?#%-\:\/\[\]]+)<!-{2}<\/wikitalk>-{3}>\n';
$Page = preg_replace ("/$Pattern/", "", $Page);

// the 'wikitalk' bar at the page footer
$Pattern = '<!-{2}<wikitalk>-{3}>([[:alnum:][:space:]<>_=|,.?#%-\:\/\[\]]+)<!-{2}<\/wikitalk>-{3}>';
$Page = preg_replace ("/$Pattern/", "", $Page);

// the 'wikinav' bar at the page header/footer
$Pattern = '<!-{2}<wikinav>-{3}>([[:alnum:][:space:]<>_=|,.?#%-\:\/\[\]]+)<!-{2}<\/wikinav>-{3}>';
$Page = preg_replace ("/$Pattern/", "", $Page);

// remove special <pre> tags
$Pattern = '<!-{2}REMOVE-{3}><pre>\n';
$Page = preg_replace ("/$Pattern/", "", $Page);
$Pattern = '<\/pre><!-{2}TAG-{3}>\n';
$Page = preg_replace ("/$Pattern/", "", $Page);

// remove these page spanning tags
$Pattern = '(<!-{2}REMOVE-{3}>)([a-zA-Z0-9 :?=\/\'\.,&_;-]+)(<!-{2}THIS-{3}>)';
$Page = preg_replace ("/$Pattern/", "", $Page);

// category tags
$Pattern = '\[{2}Category:([a-zA-Z0-9 :?=\/\'\.,&_;-]+)\]{2}';
$Page = preg_replace ("/$Pattern/", "", $Page);

// displaytitle tags
$Pattern = '\{{2}DISPLAYTITLE:([a-zA-Z0-9 :?=\/\'\.,&_;-]+)\}{2}';
$Page = preg_replace ("/$Pattern/", "", $Page);

// notoc tags
$Pattern = '_{2}NOTOC_{2}';
$Page = preg_replace ("/$Pattern/", "", $Page);

// END these items have "wiki" only meaning so delete them

// these items caused the "wiki" page to render improperly so they were
// commented out, but need to be restored as the docs get translated back to 'html'
$Pattern = '<!-{2}<\/dt>-{3}>';
$Page = preg_replace ("/$Pattern/", "</dt>", $Page);
$Pattern = '<!-{2}<\/dd>-{3}>';
$Page = preg_replace ("/$Pattern/", "</dd>", $Page);

// BEGIN items that get translated from "wiki" markup back to "html"

// WELCOME internal links (should be in Documentation Namespace)
$Pattern = '\[{2}Documentation:([a-zA-Z\_]+)([0-9])\.([0-9])\|([a-zA-Z\ ]+)\]\]';
$Page = preg_replace ("/$Pattern/", "<a href=\"#\\2.\\3\">\\4</a>", $Page);
// WELCOME internal links

// other internal links - more than just simple pattern matching
$Pattern = '\[{2}([a-zA-Z]+):';
if (preg_match(("/$Pattern/"), $Page)) {
	$Page = GetLinkInfo ($Page, $DocMap);
	}

// remove these tags because they aren't needed anymore
$Pattern = '<!-{2}<linkto \"(['.$SetB.']+)\">(['.$SetB.']+)<\/linkto>-{3}>';
$Page = preg_replace ("/$Pattern/", "", $Page);

/* -- disabled
// the commented out format(2) - deprecated
$Pattern = '<!-{2}<indexentry ([a-zA-Z0-9 \"\/:+,.#_-]+)>-{3}>([\s]+)';
$Page = preg_replace ("/$Pattern/", "", $Page);

$Pattern = '<!-{2}<indexentry ([a-zA-Z0-9 \"\/:+,.#_-]+)>-{3}>';
$Page = preg_replace ("/$Pattern/", "", $Page);
-- */

// the MultiLinkAndIndex extension format(2) - new
if ($Platform != "Windows") {
	// picks up a stray line ending character
	$Pattern = '\{\{#indexentry:([a-zA-Z0-9 \"\/|:+,.#_-]+)\}\}([\s]+)';
	$Page = preg_replace ("/$Pattern/", "", $Page);

	// some lines don't have the above ending
	$Pattern = '\{\{#indexentry:([a-zA-Z0-9 \"\/|:+,.#_-]+)\}\}';
	$Page = preg_replace ("/$Pattern/", "", $Page);
	}

$Pattern = '<!-{2}<sectiondesc desc=<([a-zA-Z0-9 \"]+)>-{3}>([\s]+)';
$Page = preg_replace ("/$Pattern/", "", $Page);

// external links 'http & news & ftp'
$Pattern = '\[([fhtpnews]+):\/\/([a-zA-Z0-9\/\.\:@,#_-]+) ([a-zA-Z0-9 \/\.\:,&_;-]+)\]';
$Page = preg_replace ("/$Pattern/", "<a href=\"\${1}://\${2}\">\${3}</a>", $Page);

// image links - more than just simple pattern matching
$Pattern = '\[\[Image:';
if (preg_match(("/$Pattern/"), $Page)) {
	$Page = GetMDHash ($Page, $Images);
	}

// section headings - matches h2,h3 ...
$Pattern = "(\={2,})([".$SetB."]+)(\={2,})";
if (preg_match(("/$Pattern/"), $Page)) {
	$Page = GetAnchorInfo ($Page, $DocMap, $PageTitle);
	}
// END items that get translated from "wiki" markup back to "html"

// clobber unescaped "<" and ">" with their escaped html versions
$Pattern = '<([0-9 .,-]+)>';
$Page = preg_replace ("/$Pattern/", "&lt;\${1}&gt;", $Page);

return $Page;}
// end of function FixTags

/* --

	This resolves MOST of the information needed to build the document map

-- */

function BuildDocMap ($Pages, $WikiPageTitle, $FileBrand) {
/* Initialize */
$Entry = 0;
$Section = 1;
$FirstTime = "true";
$IsSubsection = "";
$NewSubsection = "true";
$SubsectionLevel1 = 1;
$SubsectionLevel2 = 1;
$SubsectionLevel3 = 1;
$SubsectionLevel4 = 1;
$SSL2 = "";
$SSL3 = "";
$SSL4 = "";

foreach ($Pages as $Page) {
	if ($Page) {
		foreach ($Page as $Lines) {
			$Line = explode ("\n", $Lines);
			foreach ($Line as $LinesWorth) {
				// test for line types
				// THIS IS ORDER SPECIFIC

				// sub-section header
				if (preg_match("/^==/", $LinesWorth)) {
					// create a new entry
					$DocMap[$Entry] = new DocumentMap ();
					$IsSubsection = "true";
					$NewSubsection = "true";
					$Subsection++;
					$SubsectionLevel1 = 1;

					$SectionEntry = $Section.".".$Subsection;

					$DocMap[$Entry]->setFormat ("h2");
					$DocMap[$Entry]->parseTOCLink ("subheader", $LinesWorth);
					$DocMap[$Entry]->setIndex ($SectionEntry);
					$DocMap[$Entry]->setPrev ("not");
					$DocMap[$Entry]->setNext ("done yet");
					$DocMap[$Entry]->setAnchor ($FileBrand);
					$DocMap[$Entry++]->setLocalFN ($FileBrand);
					}

				// section header (tut, ref, win ...)
				elseif (preg_match("/^=/", $LinesWorth)) {
					// create a new entry
					$DocMap[$Entry] = new DocumentMap ();

					if ($FirstTime) {
						$FirstTime = "";
						$Subsection = 0;
						}
					else {
						$Subsection = 0;
						$Section++;
						}

					if ($IsSubsection) {
						$Subsection = 0;
						$IsSubsection = "";
						}

					$SectionEntry = $Section.".".$Subsection;

					$DocMap[$Entry]->setFormat ("h1");
					$DocMap[$Entry]->parseTOCLink ("header", $LinesWorth);
					$DocMap[$Entry]->setIndex ($SectionEntry);
					$DocMap[$Entry]->setPrev ("not");
					$DocMap[$Entry]->setNext ("done yet");
					$DocMap[$Entry]->setWikiFN ($WikiPageTitle, $FileBrand); // this call ONLY for the header section
					$DocMap[$Entry]->setAnchor ($FileBrand);
					$DocMap[$Entry++]->setLocalFN ($FileBrand);
					}

				// subsection level 4 header
				elseif (preg_match("/^::::/", $LinesWorth)) {
					// create a new entry
					$DocMap[$Entry] = new DocumentMap ();
					$SSL4 = "true";

					$SectionEntry = $Section.".".$Subsection.".".($SubsectionLevel1-1).".".($SubsectionLevel2-1).".";
					$SectionEntry = $SectionEntry.($SubsectionLevel3-1).".".$SubsectionLevel4++;

					$DocMap[$Entry]->setFormat ("h6");
					$DocMap[$Entry]->parseTOCLink ("l4", $LinesWorth);
					$DocMap[$Entry]->setIndex ($SectionEntry);
					$DocMap[$Entry]->setPrev ("not");
					$DocMap[$Entry]->setNext ("done yet");
					$DocMap[$Entry]->setAnchor ($FileBrand);
					$DocMap[$Entry++]->setLocalFN ($FileBrand);
					}

				// subsection level 3 header
				elseif (preg_match("/^:::/", $LinesWorth)) {
					// create a new entry
					$DocMap[$Entry] = new DocumentMap ();
					$SSL3 = "true";
					if ($SSL4) {
						$SubsectionLevel4 = "1";
						$SSL4 = "";
						}

					$SectionEntry = $Section.".".$Subsection.".".($SubsectionLevel1-1).".".($SubsectionLevel2-1).".";
					$SectionEntry = $SectionEntry.$SubsectionLevel3++;

					$DocMap[$Entry]->setFormat ("h5");
					$DocMap[$Entry]->parseTOCLink ("l3", $LinesWorth);
					$DocMap[$Entry]->setIndex ($SectionEntry);
					$DocMap[$Entry]->setPrev ("not");
					$DocMap[$Entry]->setNext ("done yet");
					$DocMap[$Entry]->setAnchor ($FileBrand);
					$DocMap[$Entry++]->setLocalFN ($FileBrand);
					}

				// subsection level 2 header
				elseif (preg_match("/^::/", $LinesWorth)) {
					// create a new entry
					$DocMap[$Entry] = new DocumentMap ();
					$SSL2 = "true";
					if ($SSL3) {
						$SubsectionLevel3 = "1";
						$SSL3 = "";
						}

					$SectionEntry = $Section.".".$Subsection.".".($SubsectionLevel1-1).".".$SubsectionLevel2++;

					$DocMap[$Entry]->setFormat ("h4");
					$DocMap[$Entry]->parseTOCLink ("l2", $LinesWorth);
					$DocMap[$Entry]->setIndex ($SectionEntry);
					$DocMap[$Entry]->setPrev ("not");
					$DocMap[$Entry]->setNext ("done yet");
					$DocMap[$Entry]->setAnchor ($FileBrand);
					$DocMap[$Entry++]->setLocalFN ($FileBrand);
					}

				// subsection level 1 header
				elseif (preg_match("/^:/", $LinesWorth)) {
					// create a new entry
					$DocMap[$Entry] = new DocumentMap ();
					if ($SSL2) {
						$SubsectionLevel2 = "1";
						$SSL2 = "";
						}

					if ($NewSubsection) {
						$NewSubsection = "";
						}

					$SectionEntry = $Section.".".$Subsection.".".$SubsectionLevel1++;

					$DocMap[$Entry]->setFormat ("h3");
					$DocMap[$Entry]->parseTOCLink ("l1", $LinesWorth);
					$DocMap[$Entry]->setIndex ($SectionEntry);
					$DocMap[$Entry]->setPrev ("not");
					$DocMap[$Entry]->setNext ("done yet");
					$DocMap[$Entry]->setAnchor ($FileBrand);
					$DocMap[$Entry++]->setLocalFN ($FileBrand);
					}

				}	//foreach LinesWorth
			}	//foreach Lines
		}	//if Pages
	}	//foreach Pages

return ($DocMap);}
// end function BuildDocMap

/* --

	Resolves the navigation prev/next navigation aids

--- */

function CompleteDocMap ($DocMap) {
// Resolves the Next & Previous Nav Aids
$Count = 0;
while ($Count < count ($DocMap)) {
	switch ($Count) {
		case 0:
			$DocMap[$Count]->setPrev("Top");
			$Next = $DocMap[$Count + 1]->getIndex()."|".$DocMap[$Count + 1]->getTitle();
			$DocMap[$Count]->setNext($Next);
		break;
		case count ($DocMap)-1:
			$Prev = $DocMap[$Count - 1]->getIndex()."|".$DocMap[$Count - 1]->getTitle();
			$DocMap[$Count]->setPrev($Prev);
			$DocMap[$Count]->setNext("Bottom");
		break;
		default:
			$Prev = $DocMap[$Count - 1]->getIndex()."|".$DocMap[$Count - 1]->getTitle();
			$DocMap[$Count]->setPrev($Prev);
			$Next = $DocMap[$Count + 1]->getIndex()."|".$DocMap[$Count + 1]->getTitle();
			$DocMap[$Count]->setNext($Next);
		break;
		}
	$Count++;
	}}
// end function CompleteDocMap

/* --

	Use a KNOWN page title and gets it's namespace designation
	to prevent getting identical page names from other namespaces

-- */

function GetNameSpace ($DataBase, $Title) {
$Query = 'select page_namespace from page where page_title="' . $Title . '";';
$Result = mysql_query($Query)
	or exit (5);

while ($Row = mysql_fetch_array($Result, MYSQL_ASSOC)) {

	foreach ($Row as $Page) {
		$DocNameSpace = $Page;
		}

	}

mysql_free_result($Result);
mysql_close ($DataBase);

return $DocNameSpace;}
// end function GetNameSpace

/* --

	Inserts the page navigation at the top and bottom of the page
  and it's currently not being used.

--- */

/*function InsertPageNav ($DataBase, $DocNameSpace, $WikiTitle, $ThePage, $DocMap) {
$Query = 'select old_text from text where old_id=(select rev_text_id ';
$Query = $Query . 'from revision where rev_id=(select page_latest ';
$Query = $Query . 'from page where page_title="' . $WikiTitle . '" AND page_namespace="';
$Query = $Query . $DocNameSpace . '"));';

$Result = mysql_query($Query)
	or exit (6);

while ($Row = mysql_fetch_array($Result, MYSQL_ASSOC)) {

	foreach ($Row as $Page) {
		$Page = FixTags ($Page, $WikiTitle, "");//$Page = FixTags ($Page, $WikiTitle, $ThePage);
		echo $Page;
		}

	}

mysql_free_result($Result);
mysql_close ($DataBase);}
// end function InsertPageNav*/

/* --

	Gets the requested page from the database
	and it's currently not being used.

--- */

/*function GetPage ($DataBase, $DocNameSpace, $WikiTitle, $TheAnchor) {
$Query = 'select old_text from text where old_id=(select rev_text_id ';
$Query = $Query . 'from revision where rev_id=(select page_latest ';
$Query = $Query . 'from page where page_title="' . $WikiTitle . '" AND page_namespace="';
$Query = $Query . $DocNameSpace . '"));';

$Result = mysql_query($Query)
	or exit (7);

while ($Row = mysql_fetch_array($Result, MYSQL_ASSOC)) {

	foreach ($Row as $Page) {
		$Page = FixTags ($Page, $WikiTitle, $TheAnchor);//$Page = FixTags ($Page, $WikiTitle, "");
		echo $Page;
		}

	}

mysql_free_result($Result);
mysql_close ($DataBase);}
// end function GetPage*/

?>
